mirror of https://lore.kernel.org/lkml/
 help / color / mirror / Atom feed
From: Shuah Khan <shuah@kernel.org>
To: Masami Hiramatsu <mhiramat@kernel.org>
Cc: rostedt@goodmis.org, linux-kselftest@vger.kernel.org,
	linux-kernel@vger.kernel.org, Shuah Khan <shuah@kernel.org>
Subject: Re: [PATCH 09/24] selftests: ftrace: return Kselftest Skip code for skipped tests
Date: Thu, 10 May 2018 14:18:16 -0600	[thread overview]
Message-ID: <34a4aa44-75f0-b868-cfc8-37fc716af0a5@kernel.org> (raw)
In-Reply-To: <20180508123812.874ff8d2a22abd62148b293d@kernel.org>

Hi Masami,

On 05/07/2018 09:38 PM, Masami Hiramatsu wrote:
> On Fri,  4 May 2018 19:13:13 -0600
> "Shuah Khan (Samsung OSG)" <shuah@kernel.org> wrote:
> 
>> When ftrace test is skipped because of unmet dependencies and/or
>> unsupported configuration, it returns 0 which is treated as a pass
>> by the Kselftest framework. This leads to false positive result even
>> when the test could not be run.
>>
>> Change it to return kselftest skip code when a test gets skipped to
>> clearly report that the test could not be run.
>>
>> Kselftest framework SKIP code is 4 and the framework prints appropriate
>> messages to indicate that the test is skipped.
>>
>> Signed-off-by: Shuah Khan (Samsung OSG) <shuah@kernel.org>
>> ---
>>  tools/testing/selftests/ftrace/ftracetest | 8 ++++++--
>>  1 file changed, 6 insertions(+), 2 deletions(-)
>>
>> diff --git a/tools/testing/selftests/ftrace/ftracetest b/tools/testing/selftests/ftrace/ftracetest
>> index f9a9d424c980..b731c8cdcffb 100755
>> --- a/tools/testing/selftests/ftrace/ftracetest
>> +++ b/tools/testing/selftests/ftrace/ftracetest
>> @@ -23,6 +23,9 @@ echo "		            If <dir> is -, all logs output in console only"
>>  exit $1
>>  }
>>  
>> +# Kselftest framework requirement - SKIP code is 4.
>> +ksft_skip=4
>> +
>>  errexit() { # message
>>    echo "Error: $1" 1>&2
>>    exit 1
>> @@ -30,7 +33,8 @@ errexit() { # message
>>  
>>  # Ensuring user privilege
>>  if [ `id -u` -ne 0 ]; then
>> -  errexit "this must be run by root user"
>> +  echo "Skipping: test must be run by root user"
>> +  exit $ksft_skip
>>  fi
>>  
>>  # Utilities
>> @@ -249,7 +253,7 @@ trap 'SIG_RESULT=$UNTESTED' $SIG_UNTESTED
>>  SIG_UNSUPPORTED=$((SIG_BASE + UNSUPPORTED))
>>  exit_unsupported () {
>>    kill -s $SIG_UNSUPPORTED $SIG_PID
>> -  exit 0
>> +  exit $ksft_skip
> 
> This should return 0. If you want to change the result code,
> you have to change the last part as below.
> (Note that we need a switch option of return code, so that
>  ftracetest user can continue to use same way...)

Doesn't this existing option take care of this:

--fail-unsupported Treat UNSUPPORTED as a failure"

Is there a need for another. This indicates that the default
mode is UNSUPPORTED isn't a failure.

> 
> diff --git a/tools/testing/selftests/ftrace/ftracetest b/tools/testing/selftests/ftrace/ftracetest
> index f9a9d424c980..d6ce56a2a937 100755
> --- a/tools/testing/selftests/ftrace/ftracetest
> +++ b/tools/testing/selftests/ftrace/ftracetest
> @@ -326,5 +326,15 @@ prlog "# of unsupported: " `echo $UNSUPPORTED_CASES | wc -w`
>  prlog "# of xfailed: " `echo $XFAILED_CASES | wc -w`
>  prlog "# of undefined(test bug): " `echo $UNDEFINED_CASES | wc -w`
>  
> -# if no error, return 0
> -exit $TOTAL_RESULT
> +# following kselftest result code
> +if [ $UNSUPPORTED_CASES -ne 0 -o \
> +       $UNTESTED_CASES -ne 0 -o \
> +       $UNRESOLVED_CASES -ne 0]; then # There are skipped tests
> +  exit 4
> +elif [ $XAILED_CASES -ne 0 -o ]; then # XFAILs
> +  exit 2
> +elif [ $FAILED_CASES -ne 0 -o ]; then # FAILs
> +  exit 1
> +else # PASS
> +  exit 0
> +fi
> 

Thanks for pointing out the right change to make.

-- Shuah

  reply	other threads:[~2018-05-10 20:18 UTC|newest]

Thread overview: 41+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2018-05-05  1:13 [PATCH 01/24] selftests: android: ion: " Shuah Khan (Samsung OSG)
2018-05-05  1:13 ` [PATCH 02/24] selftests: breakpoints: " Shuah Khan (Samsung OSG)
2018-05-05  1:13 ` [PATCH 03/24] selftests: cpu-hotplug: " Shuah Khan (Samsung OSG)
2018-05-05  1:13 ` [PATCH 04/24] selftests: cpufreq: " Shuah Khan (Samsung OSG)
2018-05-07  5:01   ` Viresh Kumar
2018-05-05  1:13 ` [PATCH 05/24] selftests: efivarfs: " Shuah Khan (Samsung OSG)
2018-05-05  1:13 ` [PATCH 06/24] selftests: exec: " Shuah Khan (Samsung OSG)
2018-05-08  0:03   ` Steve Muckle
2018-05-05  1:13 ` [PATCH 07/24] selftests: filesystems: " Shuah Khan (Samsung OSG)
2018-05-06  8:15   ` Christian Brauner
2018-05-05  1:13 ` [PATCH 08/24] selftests: firmware: " Shuah Khan (Samsung OSG)
2018-05-09 19:27   ` Luis R. Rodriguez
2018-05-05  1:13 ` [PATCH 09/24] selftests: ftrace: " Shuah Khan (Samsung OSG)
2018-05-07 15:17   ` Steven Rostedt
2018-05-08  3:29     ` Masami Hiramatsu
2018-05-08  3:38   ` Masami Hiramatsu
2018-05-10 20:18     ` Shuah Khan [this message]
2018-05-11  6:09       ` Masami Hiramatsu
2018-05-05  1:13 ` [PATCH 10/24] selftests: gpio: " Shuah Khan (Samsung OSG)
2018-05-05  1:13 ` [PATCH 11/24] selftests: intel_pstate: " Shuah Khan (Samsung OSG)
2018-05-05  1:13 ` [PATCH 12/24] selftests: ipc: " Shuah Khan (Samsung OSG)
2018-05-05  1:13 ` [PATCH 13/24] selftests: kmod: " Shuah Khan (Samsung OSG)
2018-05-09 19:28   ` Luis R. Rodriguez
2018-05-05  1:13 ` [PATCH 14/24] selftests: kvm: " Shuah Khan (Samsung OSG)
2018-05-07 11:46   ` Paolo Bonzini
2018-05-07 19:41     ` Shuah Khan
2018-05-07 20:19       ` Shuah Khan
2018-05-05  1:13 ` [PATCH 15/24] selftests: lib: add prime_numbers.sh test to Makefile Shuah Khan (Samsung OSG)
2018-05-05  1:13 ` [PATCH 16/24] selftests: lib: return Kselftest Skip code for skipped tests Shuah Khan (Samsung OSG)
2018-05-05  1:13 ` [PATCH 17/24] selftests: locking: add Makefile for locking test Shuah Khan (Samsung OSG)
2018-05-05  1:13 ` [PATCH 18/24] selftests: locking: return Kselftest Skip code for skipped tests Shuah Khan (Samsung OSG)
2018-05-05  1:13 ` [PATCH 19/24] selftests: media_tests: " Shuah Khan (Samsung OSG)
2018-05-05  1:13 ` [PATCH 20/24] selftests: membarrier: " Shuah Khan (Samsung OSG)
2018-05-05  1:13 ` [PATCH 21/24] selftests: memfd: " Shuah Khan (Samsung OSG)
2018-05-05  1:52   ` Mike Kravetz
2018-05-07 18:45     ` Shuah Khan
2018-05-07 21:16       ` Shuah Khan
2018-05-05  1:13 ` [PATCH 22/24] selftests: memory-hotplug: " Shuah Khan (Samsung OSG)
2018-05-05  1:13 ` [PATCH 23/24] selftests: mqueue: " Shuah Khan (Samsung OSG)
2018-05-05  1:13 ` [PATCH 24/24] selftests: net: " Shuah Khan (Samsung OSG)
2018-05-07 11:04 ` [PATCH 01/24] selftests: android: ion: " Pintu Kumar

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=34a4aa44-75f0-b868-cfc8-37fc716af0a5@kernel.org \
    --to=shuah@kernel.org \
    --cc=linux-kernel@vger.kernel.org \
    --cc=linux-kselftest@vger.kernel.org \
    --cc=mhiramat@kernel.org \
    --cc=rostedt@goodmis.org \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox

Powered by JetHome